## API Report File for "@genesislcap/foundation-filters"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Auth } from '@genesislcap/foundation-comms';
import { Container } from '@microsoft/fast-foundation';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import { Logger } from '@genesislcap/foundation-utils';
import { User } from '@genesislcap/foundation-comms';

// @public
export interface ClientFilter<P = any> {
    // (undocumented)
    filter(parameters: P): boolean;
}

// @public (undocumented)
export const ClientFilterName: {
    readonly nodeEnv: "nodeEnv";
    readonly percentage: "percentage";
    readonly timeWindow: "timeWindow";
    readonly urlTargeting: "urlTargeting";
    readonly userAgent: "userAgent";
    readonly userTargeting: "userTargeting";
};

// @public (undocumented)
export type ClientFilterName = (typeof ClientFilterName)[keyof typeof ClientFilterName];

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "ClientFilterRunner" because one of its declarations is marked as @internal
//
// @public
export interface ClientFilterRunner {
    // (undocumented)
    run(filters: ClientFilterSchemas[], container?: Container): boolean;
}

// @internal
export const ClientFilterRunner: InterfaceSymbol<ClientFilterRunner>;

// @public
export type ClientFilterSchema<N extends ClientFilterName, P> = {
    readonly name: N;
    readonly parameters: P;
};

// @public
export type ClientFilterSchemas = NodeEnvSchema | PercentageSchema | TimeWindowSchema | URLTargetingSchema | UserAgentSchema | UserTargetingSchema;

// @public
export class DefaultClientFilterRunner implements ClientFilterRunner {
    // (undocumented)
    container: Container;
    // (undocumented)
    run(filters: ClientFilterSchemas[], container?: Container): boolean;
}

// @public
export class DefaultNodeEnv implements NodeEnv {
    // (undocumented)
    filter(params: NodeEnvParams): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NodeEnv" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get isDevelopment(): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NodeEnv" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get isProduction(): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NodeEnv" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get isTesting(): boolean;
}

// @public
export class DefaultPercentage implements Percentage {
    // (undocumented)
    filter(params: PercentageParams): boolean;
}

// @public
export class DefaultTimeWindow implements TimeWindow {
    // (undocumented)
    filter(params: TimeWindowParams): boolean;
}

// @public
export class DefaultURLTargeting implements URLTargeting {
    // (undocumented)
    filter(params: URLTargetingParams): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "URLTargeting" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    isSecure(url: any): boolean;
}

// @public
export class DefaultUserAgent implements UserAgent {
    // (undocumented)
    filter(params: UserAgentParams): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "UserAgent" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get isSafari(): boolean;
}

// @public
export class DefaultUserTargeting implements UserTargeting {
    constructor(auth: Auth);
    // (undocumented)
    auth: Auth;
    // (undocumented)
    filter(params: UserTargetingParams): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "UserTargeting" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get hasAdminProfile(): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "UserTargeting" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get isLoggedIn(): boolean;
}

// @public
export function getFilterByName(name: ClientFilterName, container: Container): NodeEnv | Percentage | TimeWindow | URLTargeting | UserAgent | UserTargeting;

// @public
export const logger: Logger;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "NodeEnv" because one of its declarations is marked as @internal
//
// @public
export interface NodeEnv extends ClientFilter<NodeEnvParams> {
    // (undocumented)
    readonly isDevelopment: boolean;
    // (undocumented)
    readonly isProduction: boolean;
    // (undocumented)
    readonly isTesting: boolean;
}

// @internal
export const NodeEnv: InterfaceSymbol<NodeEnv>;

// @public
export function nodeEnvFilter(envs: string[]): boolean;

// @public
export type NodeEnvParams = {
    readonly envs: string[];
};

// @public
export type NodeEnvSchema = ClientFilterSchema<typeof ClientFilterName.nodeEnv, NodeEnvParams>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Percentage" because one of its declarations is marked as @internal
//
// @public
export interface Percentage extends ClientFilter<PercentageParams> {
}

// @internal
export const Percentage: InterfaceSymbol<Percentage>;

// @public
export function percentageFilter(percent: number, random?: number): boolean;

// @public
export type PercentageParams = {
    readonly percent: number;
    readonly random?: number;
};

// @public
export type PercentageSchema = ClientFilterSchema<typeof ClientFilterName.percentage, PercentageParams>;

// @public
export function runner(filters: ClientFilterSchemas[], container: Container): boolean;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "TimeWindow" because one of its declarations is marked as @internal
//
// @public
export interface TimeWindow extends ClientFilter<TimeWindowParams> {
}

// @internal
export const TimeWindow: InterfaceSymbol<TimeWindow>;

// @public
export function timeWindowFilter(start?: string, end?: string): boolean;

// @public
export type TimeWindowParams = {
    readonly start?: string;
    readonly end?: string;
};

// @public
export type TimeWindowSchema = ClientFilterSchema<typeof ClientFilterName.timeWindow, TimeWindowParams>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "URLTargeting" because one of its declarations is marked as @internal
//
// @public
export interface URLTargeting extends ClientFilter<URLTargetingParams> {
    // (undocumented)
    isSecure(url: string): boolean;
}

// @internal
export const URLTargeting: InterfaceSymbol<URLTargeting>;

// @public
export function urlTargetingFilter(url: string, pattern?: RegExp, schemes?: string[], hosts?: string[], paths?: string[]): boolean;

// @public
export type URLTargetingParams = {
    readonly url?: string;
    readonly pattern?: RegExp;
    readonly schemes?: string[];
    readonly hosts?: string[];
    readonly paths?: string[];
};

// @public
export type URLTargetingSchema = ClientFilterSchema<typeof ClientFilterName.urlTargeting, URLTargetingParams>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "UserAgent" because one of its declarations is marked as @internal
//
// @public
export interface UserAgent extends ClientFilter<UserAgentParams> {
    // (undocumented)
    readonly isSafari: boolean;
}

// @internal
export const UserAgent: InterfaceSymbol<UserAgent>;

// @public
export function userAgentFilter(browsers?: string[], devices?: string[], oss?: string[], ua?: string): boolean;

// @public
export type UserAgentParams = {
    readonly browsers?: string[];
    readonly devices?: string[];
    readonly oss?: string[];
    readonly ua?: string;
};

// @public
export type UserAgentSchema = ClientFilterSchema<typeof ClientFilterName.userAgent, UserAgentParams>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "UserTargeting" because one of its declarations is marked as @internal
//
// @public
export interface UserTargeting extends ClientFilter<UserTargetingParams> {
    // (undocumented)
    readonly hasAdminProfile: boolean;
    // (undocumented)
    readonly isLoggedIn: boolean;
}

// @internal
export const UserTargeting: InterfaceSymbol<UserTargeting>;

// @public
export function userTargetingFilter(user: User, usernames?: string[], profiles?: string[], permissions?: string[]): boolean;

// @public
export type UserTargetingParams = {
    readonly usernames?: string[];
    readonly profiles?: string[];
    readonly permissions?: string[];
};

// @public
export type UserTargetingSchema = ClientFilterSchema<typeof ClientFilterName.userTargeting, UserTargetingParams>;

// (No @packageDocumentation comment for this package)

```
